<?php

namespace RxConnexionBundle\Controller;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;

use RxConnexionBundle\Entity\AuditTrailEntity;
use RxConnexionBundle\Entity\HealthFacilityEntity;

use RxConnexionBundle\Form\HealthFacilityForm;

/**
 * @Route("/main/health_facility")
 */
class HealthFacilityController extends Controller
{
    /**
     * @Route("", name="health_facility")
     */
    public function indexAction() {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Health Facility'))) return $authService->redirectToHome();

        return $this->render('@RxConnexion/HealthFacility/index.html.twig', array(
            'title' => 'Manage Branch',
            'page_title' => 'Manage Branch',
            'javascripts' => array('rxconnexion/admin/js/healthFacility/healthFacility.js?v=1.0.0')
        ));
    }

    /**
     * @Route("/ajax_list", name="health_facility_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {

            $hasUpdate = $authService->isUserHasAccesses(array('Admin Health Facility Update'), false);

            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:HealthFacilityEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('health_facility_form', array(
                        'action' => 'u',
                        'id' => $id
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }

                $values = array(
                    $row['id'],
                    $row['company_description'],
                    $row['description'],
                    $row['address'],
                    $row['schedule_type'],
                    $row['mobile_no'],
                    $row['phone_no'],
                    $row['email'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "health_facility_form"
     * )
     */
    public function formAction($action, $id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Health Facility New', 'Admin Health Facility Update'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $healthFacility = $em->getRepository('RxConnexionBundle:HealthFacilityEntity')->find(base64_decode($id));
        if(!$healthFacility) {
            $healthFacility = new HealthFacilityEntity();
        }

        $formOptions = array('action' => $action);
        $form = $this->createForm(HealthFacilityForm::class, $healthFacility, $formOptions);

        if($request->getMethod() === 'POST') {

            $healthFacility_form = $request->get($form->getName());
            $result = $this->processForm($healthFacility_form, $healthFacility, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('health_facility'), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('health_facility_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id'])
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('health_facility_form'), 302);
                }
            } else {
                $form->submit($healthFacility_form, false);
            }
        }

        $title = ($action === 'n' ? 'New' : 'Update') . ' Branch';

        return $this->render('@RxConnexion/HealthFacility/form.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'javascripts' => array('rxconnexion/admin/js/healthFacility/healthFacility_form.js?v=1.0.0'),
            'form' => $form->createView(),
            'action' => $action,
            'id' => $id
        ));
    }

    private function processForm($healthFacility_form, $healthFacility, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();

        $errors = $em->getRepository('RxConnexionBundle:HealthFacilityEntity')->validate($healthFacility_form);

        if(!count($errors)) {

            switch($healthFacility_form['action']) {

                case 'n': // new

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $em->persist($healthFacility);

                        $postalCode = $em->getRepository('RxConnexionBundle:PostalCodeEntity')->find($healthFacility_form['postalCode']);
                        $apiUrl = 'https://maps.googleapis.com/maps/api/geocode/json?address=' . urlencode($healthFacility_form['street'] . ' ' . $postalCode->getCity()->getDescription() . ', ' . $postalCode->getCity()->getProvince()->getDescription() . ' ' . $postalCode->getCity()->getProvince()->getCountry()->getDescription() . ' ' . $postalCode->getDescription()) . '&key=' .$this->container->getParameter('google_map_api_key');

                        try {
                            $headers = get_headers($apiUrl, 1);
                        } catch(\Exception $e) {
                            $headers = FALSE;
                        }

                        if($headers !== FALSE && substr($headers[0], 9, 3) === '200') {

                            $apiData = json_decode(file_get_contents($apiUrl), true);

                            if(count($apiData) && isSet($apiData['status'])) {

                                if($apiData['status'] === 'OK') {
                                    $healthFacility->setGeoLatitude($apiData['results'][0]['geometry']['location']['lat']);
                                    $healthFacility->setGeoLongitude($apiData['results'][0]['geometry']['location']['lng']);
                                } else {
                                    $healthFacility->setGeoLatitude(null);
                                    $healthFacility->setGeoLongitude(null);
                                }
                            }
                        }
                        $em->flush();

                        if(isset($_FILES['form']) && !empty($_FILES['form']['tmp_name']['photo'])) {

                            $baseName = $healthFacility->getId() . '-' . time() . '.' . pathinfo($_FILES['form']['name']['photo'], PATHINFO_EXTENSION);
                            $uploadFile = $healthFacility->getUploadRootDir() . '/' . $baseName;

                            if (move_uploaded_file($_FILES['form']['tmp_name']['photo'], $uploadFile)) {
                                $healthFacility->removePhotoFile();
                                $healthFacility->setPhotoDescription($_FILES['form']['name']['photo']);
                                $healthFacility->setParsedPhotoDescription($baseName);
                                $em->flush();

                            }
                        }

                        $newAT = new AuditTrailEntity(
                            'Health Facility',
                            $em->getClassMetadata(HealthFacilityEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $healthFacility;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'Health Facility',
                        $em->getClassMetadata(HealthFacilityEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $healthFacility;
                    $newAT->parseOriginalDetails();

                    $form->handleRequest($request);

                    if ($form->isValid()) {
                        $postalCode = $em->getRepository('RxConnexionBundle:PostalCodeEntity')->find($healthFacility_form['postalCode']);
                        $apiUrl = 'https://maps.googleapis.com/maps/api/geocode/json?address=' . urlencode($healthFacility_form['street'] . ' ' . $postalCode->getCity()->getDescription() . ', ' . $postalCode->getCity()->getProvince()->getDescription() . ' ' . $postalCode->getCity()->getProvince()->getCountry()->getDescription() . ' ' . $postalCode->getDescription()) . '&key=' .$this->container->getParameter('google_map_api_key');
                        try {
                            $headers = get_headers($apiUrl, 1);
                        } catch(\Exception $e) {
                            $headers = FALSE;
                        }

                        if($headers !== FALSE && substr($headers[0], 9, 3) === '200') {

                            $apiData = json_decode(file_get_contents($apiUrl), true);


                            if(count($apiData) && isSet($apiData['status'])) {
                                if($apiData['status'] === 'OK') {
                                    $healthFacility->setGeoLatitude($apiData['results'][0]['geometry']['location']['lat']);
                                    $healthFacility->setGeoLongitude($apiData['results'][0]['geometry']['location']['lng']);
                                } else {
                                    $healthFacility->setGeoLatitude(null);
                                    $healthFacility->setGeoLongitude(null);
                                }
                            }
                        }

                        $healthFacility_obj = $em->getRepository('RxConnexionBundle:HealthFacilityEntity')->find($healthFacility_form['id']);
                        $newAT->parseDetails();
                        $em->persist($newAT);

                        $em->flush();
                        if(isset($_FILES['form']) && !empty($_FILES['form']['tmp_name']['photo'])) {

                            $baseName = $healthFacility_obj->getId() . '-' . time() . '.' . pathinfo($_FILES['form']['name']['photo'], PATHINFO_EXTENSION);
                            $uploadFile = $healthFacility_obj->getUploadRootDir() . '/' . $baseName;

                            if (move_uploaded_file($_FILES['form']['tmp_name']['photo'], $uploadFile)) {
                                $healthFacility_obj->removePhotoFile();
                                $healthFacility_obj->setPhotoDescription($_FILES['form']['name']['photo']);
                                $healthFacility_obj->setParsedPhotoDescription($baseName);
                                $em->flush();

                            }
                        }

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $newAT = new AuditTrailEntity(
                        'Health Facility',
                        $em->getClassMetadata(HealthFacilityEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $healthFacility;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        //$em->remove($healthFacility);
                        $healthFacility->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route("/autocomplete", name="health_facility_autocomplete")
     */
    public function autocompleteAction(Request $request) {

        $q = $request->get('query');
        $userData = $this->get('session')->get('userData');

        $result = array(
            'query' => 'cities',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:HealthFacilityEntity')->autocomplete_suggestions($q,$userData),
        );

        return new JsonResponse($result);
    }

    /**
     * @Route("/autocomplete_for_schedule", name="health_facility_autocomplete_for_schedule")
     */
    public function autocomplete_for_scheduleAction(Request $request) {

        $q = $request->get('query');
        $provider_id = $request->query->get('provider_id');

        $result = array(
            'query' => 'cities',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:HealthFacilityEntity')->schedule_healthFacility_autocomplete_suggestions($q, $provider_id)
        );

        return new JsonResponse($result);
    }

    /**
     * @Route("/autocomplete_for_billing", name="health_facility_autocomplete_for_billing")
     */
    public function autocomplete_for_billingAction(Request $request) {

        $q = $request->get('query');

        $result = array(
            'query' => 'cities',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:HealthFacilityEntity')->billing_healthFacility_autocomplete_suggestions($q)
        );

        return new JsonResponse($result);
    }
}
